type: prog

uuid: 00009103-1b43-0526-2022-111900000012

titre: Les résultats de type 'objet'

niveau: Intermédiaire

description: Apprendre à gérer les résultats de type objet.

énoncé: |
  Comme nous sommes en mode orienté-objet, il est très important de comprendre ce qui se produit quand une instruction ne retourne aucune valeur.  Par exemple, dans mon script, je désire vérifier si le service 12345678 existe.  L'instruction `Get-Service`, couplée à l'instruction `Where-Object` peut être utilisé pour faire cette validation.  Par contre, comment savoir si une valeur a été trouvée ou non?  Quand on le sait, c'est très simple.  Quand on ne le sait pas, c'est un cauchemar de programmation.  Donc les instructions retournent des objets.  Dans le cas de l'instruction `Get-Service`, l'objet retourné est de type `ServiceController` quand il y a un résultat.  Sinon, $null est retourné.  Donc, dans le cas proposé, si le service n'est pas trouvé, j'obtiendrai $null comme retour.  Sinon le service est trouvé et j'obtiendrai les informations de ce service dans un objet de type `ServiceController`.
  Vous devez maintenant utiliser l'instruction `Get-Process` pour chercher le nom du processus reçu en paramètre via la variable `PName`.  Si vous ne trouvez pas le processus, vous devez afficher le message `Processus non trouvé`.  Sinon vous affichez le message `Processus trouvé`.

  À faire :

  1. Compléter le script en remplaçant les `??` pour réussir l'exercice.  Vous devez utiliser `Get-Process` et le `Where-Object`.
  2. Exécuter le script et corriger les erreurs s'il y a lieu.

ébauches:
    powershell: !include exec.powershell

rétroactions:
    positive: Bravo! tu as réussi à vérifier si tu as reçu comme résultat un objet ou $null!
    négative: Hum...  Relire l'énoncé attentivement.

tests: !include tests.yml

auteur: Gilles Lacasse
licence: 2022 CC-BY-SA
